require('dotenv');
const autenticacaoRequest = require('../request/autenticacao-request');

module.exports = {
    name: 'autorizacao-jwt',
    policy: (actionParams) => {

        return (req, res, next) => {

            let urlAutorizacao = actionParams.url.autorizacao;

            let token = req.headers.authorization;

            autenticacaoRequest.validaToken(token, urlAutorizacao).then((response) => {

                req.headers.idcliente = response.body.id_cliente;
                req.headers.idusuario = response.body.id_usuario;
                req.headers.dshost = response.body.ds_hostacesso;
                req.headers.idempresa = response.body.id_empresa;

                return next();

            }).catch((response) => {

                if (response.statusCode) {
                    return res.status(response.statusCode).send(response.error);
                } else {
                    return res.status(500).send(response);
                }

            });

        };
    }
};