const odinRequest = require('odin-request-retry');

const getInformacaoResumida = (autenticacao, urlInfoResumida) => {

    return new Promise((resolve) => {

        let requestTemplate = {
            url: urlInfoResumida,
            method: 'GET',
            headers: {
                idcliente: autenticacao.id_cliente,
                idusuario: autenticacao.id_usuario,
                host: autenticacao.ds_hostacesso
            },
            resolveWithFullResponse: true,
            json: autenticacao
        };

        return resolve(odinRequest.request(requestTemplate, 2));

    });
};

const validaAcessoEmpresa = (autenticacao, idEmpresa, urlValidaAcessoEmpresa) => {

    return new Promise((resolve, reject) => {

        let requestTemplate = {
            url: urlValidaAcessoEmpresa,
            method: 'GET',
            qs: {
                idEmpresa: idEmpresa
            },
            headers: {
                idcliente: autenticacao.id_cliente,
                idusuario: autenticacao.id_usuario,
                host: autenticacao.ds_hostacesso
            },
            resolveWithFullResponse: true
        };

        odinRequest.request(requestTemplate, 2).then((response) => {
            return resolve(JSON.parse(response.body).data);
        }).catch((err) => {
            return reject(err);
        });

    });
};

module.exports = {
    getInformacaoResumida,
    validaAcessoEmpresa
};